#!/bin/bash

NET_IFACE=ens32
L2TP_NET=192.168.42.0/24
XAUTH_NET=192.168.43.0/24

update_iptables() {
    #IPT_FILE=/etc/iptables.rules
    #IPT_FILE2=/etc/iptables/rules.v4

    systemctl stop fail2ban >/dev/null 2>&1

    #iptables-save > "$IPT_FILE.old-$SYS_DT"
    iptables -t filter -I UNAS_L2TP_INPUT 1 -p udp --dport 1701 -m policy --dir in --pol none -j DROP
    iptables -t filter -I UNAS_L2TP_INPUT 2 -m conntrack --ctstate INVALID -j DROP
    iptables -t filter -I UNAS_L2TP_INPUT 3 -m conntrack --ctstate "RELATED,ESTABLISHED" -j ACCEPT
    iptables -t filter -I UNAS_L2TP_INPUT 4 -p udp -m multiport --dports 500,4500 -j ACCEPT
    iptables -t filter -I UNAS_L2TP_INPUT 5 -p udp --dport 1701 -m policy --dir in --pol ipsec -j ACCEPT
    iptables -t filter -I UNAS_L2TP_INPUT 6 -p udp --dport 1701 -j DROP
    iptables -t filter -I UNAS_L2TP_FORWARD 1 -m conntrack --ctstate INVALID -j DROP
    iptables -t filter -I UNAS_L2TP_FORWARD 2 -i "$NET_IFACE" -o ppp+ -m conntrack --ctstate "RELATED,ESTABLISHED" -j ACCEPT
    iptables -t filter -I UNAS_L2TP_FORWARD 3 -i ppp+ -o "$NET_IFACE" -j ACCEPT
    iptables -t filter -I UNAS_L2TP_FORWARD 4 -i ppp+ -o ppp+ -j ACCEPT
    iptables -t filter -I UNAS_L2TP_FORWARD 5 -i "$NET_IFACE" -d "$XAUTH_NET" -m conntrack --ctstate "RELATED,ESTABLISHED" -j ACCEPT
    iptables -t filter -I UNAS_L2TP_FORWARD 6 -s "$XAUTH_NET" -o "$NET_IFACE" -j ACCEPT
    iptables -t filter -I UNAS_L2TP_FORWARD 7 -s "$XAUTH_NET" -o ppp+ -j ACCEPT
    iptables -t filter -A UNAS_L2TP_FORWARD -j DROP
    iptables -t nat -I UNAS_L2TP_POSTROUTING -s "$XAUTH_NET" -o "$NET_IFACE" -m policy --dir out --pol none -j MASQUERADE
    iptables -t nat -I UNAS_L2TP_POSTROUTING -s "$L2TP_NET" -o "$NET_IFACE" -j MASQUERADE

    #iptables-save >> "$IPT_FILE"
    #if [ -f "$IPT_FILE2" ]; then
        #/bin/cp -f "$IPT_FILE" "$IPT_FILE2"
    #fi
}

update_iptables
